#define Uses_TKeys
#define Uses_TApplication
#define Uses_TEvent
#define Uses_TRect
#define Uses_TDialog
#define Uses_TStaticText
#define Uses_TMenuBar
#define Uses_TSubMenu
#define Uses_TMenuItem
#define Uses_TStatusLine
#define Uses_TStatusItem
#define Uses_TStatusDef
#define Uses_TDeskTop
#define Uses_TEditor
#define Uses_MsgBox
#define Uses_TSItem
#define Uses_TRadioButtons
#define Uses_TFileDialog
#include <TV.H>
#include <fstream.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include "utils.cpp"
#include "sbsetup.cpp"
#include "sb.h"

const int cmReadFile  = 1001;
const int cmReadText  = 1002;
const int cmSBSetup   = 1003;

class TSpeakWindow: public TWindow
{
  public:
    TSpeakWindow(TRect r);
    virtual void sizeLimits(TPoint& min, TPoint& max);
    TEditor *editor;
    TEditor *buf;
};

TSpeakWindow::TSpeakWindow(TRect r):
              TWindowInit(&TSpeakWindow::initFrame),
              TWindow(r, "", 0)
{
  r.a.x++;
  r.a.y++;
  r.b.x--;
  r.b.y--;
  editor = new TEditor(r, 0, 0, 0, 1000);
  r.a.x = 0;
  r.a.y = 0;
  r.b.x = r.a.x;
  r.b.y = r.a.y;
  buf = new TEditor(r, 0, 0, 0, 1000);
  editor -> clipboard = buf;
  insert(editor);
}

void TSpeakWindow::sizeLimits(TPoint& min, TPoint& max)
{
  TWindow::sizeLimits(min, max);
  min.x = 20;
  min.y = 10;
}

class TMainApp: public TApplication
{
  public:
    TMainApp();
    ~TMainApp();
    static TMenuBar *initMenuBar(TRect);
    static TStatusLine *initStatusLine(TRect);
    virtual void handleEvent(TEvent& event);
    void SBSetup();
  private:
    void ReadText();
    void ReadFile();
    void ReadProc();
    TSpeakWindow *window;
    char *buf;
    char FileName[100];
    char str_buf[100];
    ifstream in;
};

TMainApp::TMainApp() :
    TProgInit( &TMainApp::initStatusLine,
               &TMainApp::initMenuBar,
               &TMainApp::initDeskTop)
{
  TRect r;
  r.a.x = 0;
  r.a.y = 0;
  r.b.x = 40;
  r.b.y = 20;
  window = new TSpeakWindow(r);
  deskTop -> insert(window);
  buf = 0;
  sb_setted = 0;
}

TMainApp::~TMainApp()
{
  if (sb_setted)
  {
    CloseSB(IRQ, IRQ_MASK);
  }
}

TMenuBar *TMainApp::initMenuBar(TRect r)
{
  r.b.y = r.a.y + 1;

  return new TMenuBar(r,
    *new TSubMenu("~~", kbAltF) +
      *new TMenuItem("~~ 䠩...", cmReadFile, kbF3, hcNoContext, "F3") +
      newLine() +
        *new TMenuItem("~~室", cmQuit, kbAltX, hcNoContext, "Alt-X") +
    *new TSubMenu("~~ன", kbAltS) +
      *new TMenuItem("~~ࠬ SoundBlaster", cmSBSetup, kbAltS, hcNoContext, "Alt-S"));
}

TStatusLine *TMainApp::initStatusLine( TRect r )
{
  r.a.y = r.b.y - 1;

  return new TStatusLine(r,
    *new TStatusDef(0, 0xFFFF) +
    *new TStatusItem("~F10~ ", kbF10, cmMenu) +
    *new TStatusItem("~Alt-X~ 室", kbAltX, cmQuit) +
    *new TStatusItem("~Shift-F1~  ⥪", kbShiftF1, cmReadText));
}

void TMainApp::handleEvent(TEvent& event)
{
  TApplication::handleEvent(event);
  if (event.what == evCommand)
  {
    switch(event.message.command)
    {
      case cmReadFile: ReadFile(); break;
      case cmReadText: ReadText(); break;
      case cmSBSetup: SBSetup(); break;
      default: break;
    }
    clearEvent(event);
  }
}

void TMainApp::ReadProc()
{
  char filename[40];

  while (*buf)
  {
    ready = 0;
    *buf = rus_toupper(*buf);
    *(buf + 1) = rus_toupper(*(buf + 1));
    if ((*buf == ' ') && (*(buf + 1) != ' '))
    {
      buf++;
      delay(200);
      ready = 1;
    }
    else
    if ((*buf == 0x0D) && (*(buf + 1) != 0x0D))
    {
      buf++;
      delay(200);
      ready = 1;
    }
    if (!ready)
    {
      if(find_a2(*buf) && find_floppy(*(buf + 1)))
      {
        sprintf(filename, "DATA\\FLOPPY\\%07d.dat", find_a2(*buf));
        buf += 2;
      }
      else
      if(find_a2(*buf) && find_a1(*(buf + 1)))
      {
        sprintf(filename, "DATA\\%03d\\%07d.dat", find_a2(*buf), find_a1(*(buf + 1)));
        buf += 2;
      }
      else
      if (find_a1(*buf) || find_a2(*buf) || find_a3(*buf))
      {
        sprintf(filename, "DATA\\ALFABET\\%07d.dat", find_a3(*buf));
        buf++;
      }
      else
      {
        buf++;
        ready = 1;
      }
    }
    if (!ready)
    {
      send_file(filename, DMA);
      while (!ready) if (kbhit()) getch();
    }
  }
}

void TMainApp::ReadText()
{
  if (!sb_setted)
  {
    messageBox("ࠬ 몠쭮 \n ⠭", mfError | mfOKButton);
    return;
  }
  RESET_DSP(BASE);
  for (int i = 0; i < 1000; i++)
    window -> buf -> buffer[i] = 0;
  window -> editor -> clipCopy();
  buf = window -> buf -> buffer;
  ready = 1;
  SPKR_ON();
  ReadProc();
}

void TMainApp::SBSetup()
{
  ready = 1;
  TSBSetupDialog *d = new TSBSetupDialog(TRect(20, 5, 60, 20));
  deskTop -> execView(d);
  destroy(d);
}

void TMainApp::ReadFile()
{
  if (!sb_setted)
  {
    messageBox("ࠬ 몠쭮 \n ⠭", mfError | mfOKButton);
    return;
  }

  TFileDialog *d = new TFileDialog("*.*", "⨥ 䠩", " 䠩:", fdOpenButton, 100);
  int res = deskTop -> execView(d);
  d -> getFileName(FileName);
  destroy(d);
  if (res == cmCancel) return;

  if (in) in.close();
  in.open(FileName);
  if (!in)
  {
    messageBox("  䠩", mfError | mfOKButton);
    return;
  }

/*  file_flag = 1;
  read_flag = 1;
  ready = 1;
  in >> str_buf;
  buf = str_buf;
  RESET_DSP(BASE);
  SPKR_ON();*/
}

int main()
{
  TMainApp App;
  App.SBSetup();
  App.run();
  return 0;
}
