#ifndef _SBSETUP_CPP_
#define _SBSETUP_CPP_
#define Uses_TKeys
#define Uses_TEvent
#define Uses_TRect
#define Uses_TDialog
#define Uses_TStaticText
#define Uses_MsgBox
#define Uses_TSItem
#define Uses_TRadioButtons
#define Uses_TButton
#include <TV.H>
#include "sb.h"
#include "utils.cpp"

int sb_setted;
unsigned PORT, IRQ, IRQ_MASK, DMA;
unsigned s1 = 1, s2 = 2, s3 = 1;
int val;

class TSBSetupDialog: public TDialog
{
  public:
    TSBSetupDialog(TRect p);
    ~TSBSetupDialog();
    virtual void handleEvent(TEvent& event);
  private:
    int InitProc();
    TRadioButtons *irq, *dma, *port;
};

void TSBSetupDialog::TSBSetupDialog(TRect p):
                     TDialog(p, "ன SoundBlaster"),
                     TWindowInit(&TSBSetupDialog::initFrame)
{
  TRect r;
  int val;

  insert(new TStaticText(TRect(3, 2, 15, 3), ""));
  insert(new TStaticText(TRect(15, 2, 25, 3), "뢠"));
  insert(new TStaticText(TRect(27, 2, 38, 3), " DMA"));

  r.a.x = 3;
  r.a.y = 3;
  r.b.x = r.a.x + 10;
  r.b.y = r.a.y + 8;

  port = new TRadioButtons(r, new TSItem("2~1~0h",
                                             new TSItem("2~2~0h",
                                             new TSItem("2~3~0h",
                                             new TSItem("2~4~0h",
                                             new TSItem("2~5~0h",
                                             new TSItem("2~6~0h",
                                             new TSItem("2~7~0h",
                                             new TSItem("2~8~0h", NULL)))))))));

  val = s1;
  port -> setData((void *)&val);
  insert(port);

  r.a.x = 15;
  r.a.y = 3;
  r.b.x = r.a.x + 10;
  r.b.y = r.a.y + 6;

  irq = new TRadioButtons(r, new TSItem("~2~",
                                            new TSItem("~3~",
                                            new TSItem("~5~",
                                            new TSItem("~7~",
                                            new TSItem("1~0~",
                                            new TSItem("1~1~", NULL)))))));

  val = s2;
  irq -> setData((void *)&val);
  insert(irq);

  r.a.x = 27;
  r.a.y = 3;
  r.b.x = r.a.x + 10;
  r.b.y = r.a.y + 3;

  dma = new TRadioButtons(r, new TSItem("~0~",
                                            new TSItem("~1~",
                                            new TSItem("~3~", NULL))));

  val = s3;
  dma -> setData((void *)&val);
  insert(dma);

  insert(new TButton(TRect(21, 12, 31, 14), "⬥", cmCancel, bfNormal));
  insert(new TButton(TRect(9, 12, 19, 14), "Ok", cmOK, bfNormal));

}

void TSBSetupDialog::~TSBSetupDialog()
{
}

void TSBSetupDialog::handleEvent(TEvent& event)
{
  if (event.what == evCommand)
  {
    switch(event.message.command)
    {
      case cmOK: if (InitProc()) clearEvent(event); break;
      default: break;
    }
  }
  TDialog::handleEvent(event);
  clearEvent(event);
}

int TSBSetupDialog::InitProc()
{
  if (sb_setted)
  {
    CloseSB(IRQ, IRQ_MASK);
  }

  port -> getData((void *)&val);
  s1 = val;
  PORT = (val + 1) * 0x10 + 0x200;

  irq -> getData((void *)&val);
  s2 = val;
  switch (val)
  {
    case 0: IRQ = 2; break;
    case 1: IRQ = 3; break;
    case 2: IRQ = 5; break;
    case 3: IRQ = 7; break;
    case 4: IRQ = 10; break;
    case 5: IRQ = 11; break;
  }

  dma -> getData((void *)&val);
  s3 = val;
  switch (val)
  {
    case 0: DMA = 0; break;
    case 1: DMA = 1; break;
    case 2: DMA = 3; break;
  }

  IRQ_MASK = 1 << (IRQ % 8);

  if (!RESET_DSP(PORT))
  {
    messageBox("SoundBlaster  㦥\n 㪠 ", mfError | mfOKButton);
    sb_setted = 0;
    return 1;
  }
  else
  {
    BASE = PORT;
    if (IRQ < 8)
    {
      old_vec = getvect(IRQ + 8);
      setvect(IRQ + 8, SB_HANDLER);
      outportb(0x21, inportb(0x21) & (~IRQ_MASK));
    }
    else
    {
      old_vec = getvect(IRQ + 0x70);
      setvect(IRQ + 0x70, SB_HANDLER);
      outportb(0xA1, inportb(0xA1) & (~IRQ_MASK));
    }
    SPKR_OFF();
    PLAY(NULL, 100, 11025, DMA);
    delay(100);
    if (!ready)
    {
      messageBox("뢠 IRQ   DMA\n㪠 ୮", mfError | mfOKButton);
      sb_setted = 0;
      return 1;
    }
    else
      sb_setted = 1;
  }

  return 0;
}


#endif
